﻿using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class OnScreenStats : Mod
{
    AssetBundle bundle;
    GameObject canvas;

    Image water;
    Image carbo;
    Image protein;
    Image fat;

    public void Start()
    {
        bundle = AssetBundle.LoadFromMemory(GetEmbeddedFileBytes("onscreenstats.assets"));
        canvas = Instantiate(bundle.LoadAsset<GameObject>("Canvas"), transform);
        canvas.SetActive(SceneManager.GetActiveScene().name == "Level");
        water = canvas.transform.Find("Image").Find("Water").Find("Background").Find("ProgressBar").GetComponent<Image>();
        carbo = canvas.transform.Find("Image").Find("Carbo").Find("Background").Find("ProgressBar").GetComponent<Image>();
        protein = canvas.transform.Find("Image").Find("Proteins").Find("Background").Find("ProgressBar").GetComponent<Image>();
        fat = canvas.transform.Find("Image").Find("Fat").Find("Background").Find("ProgressBar").GetComponent<Image>();

        Debug.Log("Mod OnScreenStats has been loaded!");
    }

    public void Update()
    {
        if (SceneManager.GetActiveScene().name == "Level")
        {
            if (bundle)
            {
                if (Player.Get())
                {
                    Player p = Player.Get();
                    canvas.SetActive(true);
                    water.fillAmount = p.GetHydration() / p.GetMaxHydration();
                    carbo.fillAmount = p.GetNutritionCarbo() / p.GetMaxNutritionCarbo();
                    protein.fillAmount = p.GetNutritionProtein() / p.GetMaxNutritionProtein();
                    fat.fillAmount = p.GetNutritionFat() / p.GetMaxNutritionFat();
                    return;
                }
            }
        }
        canvas.SetActive(false);
    }

    public void OnModUnload()
    {
        if (bundle)
        {
            bundle.Unload(true);
        }
        Debug.Log("Mod OnScreenStats has been unloaded!");
    }
}